	program test_fpe_handler2
C--- Demonstrate IEEE floating point arithmetic exception handling under the
C--- Linux/Intel i386 architecture.  Five of the six floating point exception
C--- conditions are enabled together Initially and then tested individually.
C--- T.Crane, March 2003.
 	implicit double precision (a-h,o-z)
	real r
C--- Define the i387 floating point unit's interrupt mask values
	parameter (I_FPU_MASK_IM=1)	! Invalid operation mask
	parameter (I_FPU_MASK_DM=2)	! Denormalised operand mask
	parameter (I_FPU_MASK_ZM=4)	! Zero-divide mask
	parameter (I_FPU_MASK_OM=8)	! Overflow mask
	parameter (I_FPU_MASK_UM=16)	! Underflow mask
	parameter (I_FPU_MASK_PM=32)	! Precision (inexact result) mask

	print *,' Now enable; Invalid, Denormalised, Divide-by-zero'
        print *,' Overflow and Underflow interrupts' 
        call setup_fpe_handler(I_FPU_MASK_IM + I_FPU_MASK_DM +
     +                         I_FPU_MASK_ZM + I_FPU_MASK_OM +
     +			       I_FPU_MASK_UM)

	print *,'Enter test number ?'
	print *,'Test 1 - floating point overflow'
	print *,'Test 2 - invalid operation'
	print *,'Test 3 - zero-divide'
	print *,'Test 4 - denormalised result'
	print *,'Test 5 - floating point underflow'
	read (5,*) itest
	goto (1,2,3,4,5) itest
	if (itest .gt. 5) stop 'no such test'

C--- Test 1, floating point overflow
 1	continue
	a=1d300
	do while (.true.)
	 print *,'a=',a
	 a=a*10
	enddo
C---Test 2, invalid operation 
 2	continue
	a=-2
	b=sqrt(a)
	print *,'sqrt(-2)=',b
C--- Test 3, division by zero
 3	continue
	a=0
	b=1/a
	print *,'1/0=',b
C--- Test 4, denormalised result
 4	continue
	a=  2.3D-308
	print *,'a=2.3D-308=',a
	a=  2.2D-308
	print *,'a=2.2D-308=',a
C--- Test 5, floating point underflow
 5	continue
	a=1d-300
	do while (a .gt. 0d0)
	 a=a/2
	 print *,'a=',a
	enddo
	stop
	end
